/*global define, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true*/
define([
    'testsuite/qunit',
    'jquery',
    'ep/ui/editor',
    'testsuite/qunit-fixture!ckeditor/plugins/epgadget/plugin-test',

    '$ready!'
], function (QUnit, $, ep, fixture) {
    'use strict';

    QUnit.module("ckeditor/plugins/eppagebreak", {
        teardown: fixture.destroy
    });

    QUnit.fixtureVar = fixture;

    function cke_test(editorInstance, setfunction, testfunction) {
        setTimeout(function () {
            // reset CKE data
            editorInstance.setData('abc');
            // test if eppagebutton is available
            QUnit.ok(
                $('.cke_button__eppagebreak').length === 1,
                'page break button is available'
            );

            // set focus
            editorInstance.focus();

            setTimeout(function () {
                setfunction();

                setTimeout(function () {
                    QUnit.equal(
                        $('.cke_dialog').is(':visible'),
                        false,
                        'table dialog closed'
                    );

                    setTimeout(function () {
                        var data = editorInstance.getData();

                        testfunction(data);
                        QUnit.start();
                    }, 200);
                }, 200);
            }, 1000);
        }, 1000);
    }

    setTimeout(function () {

        QUnit.asyncTest("basic table plugin tests", function () {
            // Clear HTML-Remains, initiate Fixture and initiate Editor
            $('#qunit-fixture').nextAll().remove();
            QUnit.fixtureVar.init();
            ep('#uieditor_ckeditortestinstance_test1').uiEditor({
                    'name' : 'ckeditortestinstance_test1',
                    'blogPostMode': true
                });

            window.setTimeout(function () {
                var editorInstance = CKEDITOR.instances.uieditor_ckeditortestinstance_test1;

                cke_test(
                    editorInstance,
                    function () {
                    // insert page break
                    $('.cke_button__eppagebreak').trigger('click');
                    },
                    function (data) {
                        var expected = /<!-- more -->/,
                            fakeElement;

                        QUnit.ok(
                            data.search(expected) !== -1,
                            'page break was inserted to textarea'
                        );

                        // get fake element for page break from iframe
                        fakeElement = $(editorInstance.document.$.body).find('img.ckePageBreak');

                        QUnit.ok(
                            fakeElement.length === 1,
                            'fakeElement to diaplay page break in WYSIWYG was inserted'
                        );
                    }
                );
            }, 4000);
        });
    }, 200);
});